﻿Imports System.Runtime.InteropServices

Public Class Form1
  Dim SprBack As Sprite
  Dim SprCol As Sprite
  Dim SprNorm As Sprite
  Dim SprTemp As Sprite
  Dim FPS As Integer
  Dim MouseX, MouseY, MouseZ As Integer
  Dim PointLite As Boolean
  Dim Running As Boolean
  Dim Grp As Graphics
  Dim hDC As HandleRef

  Private Sub Form1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
    PointLite = Not PointLite
  End Sub

  Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    If Running Then
      e.Cancel = True
      Running = False
    End If
  End Sub

  Private Sub Form1_HandleCreated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.HandleCreated
    Grp = Me.CreateGraphics
    hDC = New HandleRef(Grp, Grp.GetHdc)
  End Sub

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    Show()
    Me.ClientSize = New System.Drawing.Size(512, 512)
    SprBack = New Sprite(ClientRectangle.Width, ClientRectangle.Height)
    SprCol = New Sprite("wall_col.jpg")
    SprNorm = New Sprite("wall_norm.jpg")
    SprTemp = New Sprite(256, 256)
    MouseZ = 96
    PointLite = True
    Running = True
    Do While Running
      System.Windows.Forms.Application.DoEvents()
      Render()
      FPS = FPS + 1
    Loop
    SprNorm = Nothing
    SprCol = Nothing
    SprTemp = Nothing
    SprBack = Nothing
    DirectCast(hDC.Wrapper, Graphics).ReleaseHdc()
    Grp.Dispose()
    Me.Dispose()
  End Sub

  Private Sub Render()
    If PointLite Then
      SprBack.DrawDPBM(SprNorm, 0, 0, MouseX, MouseY, MouseZ, 1, True)
      SprBack.DrawDPBM(SprNorm, 256, 0, MouseX, MouseY, MouseZ, 1, True)
      SprBack.DrawDPBM(SprNorm, 0, 256, MouseX, MouseY, MouseZ, 1, True)
      SprBack.DrawDPBM(SprNorm, 256, 256, MouseX, MouseY, MouseZ, 1, True)
      SprBack.Draw(SprCol, 0, 0, SR2D.Op.Mul2X)
      SprBack.Draw(SprCol, 256, 0, SR2D.Op.Mul2X)
      SprBack.Draw(SprCol, 0, 256, SR2D.Op.Mul2X)
      SprBack.Draw(SprCol, 256, 256, SR2D.Op.Mul2X)
      SprBack.PaintToDevice(hDC)
    Else
      SprTemp.DrawDPBM(SprNorm, 0, 0, MouseX - 256, MouseY - 256, MouseZ, 1)
      SprTemp.Draw(SprCol, 0, 0, SR2D.Op.Mul)
      SprBack.TileDraw(SprTemp, 0, 0, 512, 512)
      SprBack.PaintToDevice(hDC)
    End If
  End Sub

  Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
    MouseX = e.X
    MouseY = e.Y
  End Sub

  Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    Text = CStr(FPS)
    FPS = 0
  End Sub
End Class
